--
-- By HaCeSOFT
--
-- Dne 16.4.2001 ve 14:09
--
-- Hodinovy obvod pro Vyvojovou Desku
--
-- Na Vstup CLK_IN je nepretrzite privadi hodinovy signas s casovace 
-- 555. Tlacitkem SET_Hodiny se spusti hodinove impusly, ktere se 
-- objevy na vystupu CLK_OUT. Tlacitkem SET_Krok se zastavy prenos
-- hodinovych impulsu na vystup a na vystupu je LOG. 1. Tlacitkem
-- CLEAR_Krok se vystup CLK_OUT nastavy na LOG. 0. Tlacitkamy
-- SET_Krok a CLEAR_Krok vytvarite hodinove impulsi dlouhe podle
-- libosti. Kdykoliv opetovneho stisku tlacitka SET_Hodiny se na
-- vystup opet prenasi hodinove impulsi ze vstupu CLK_IN.
--
-- Upozorneni: Pokud chcete vytvaret hodinove inpulsi o libovolne
-- delce. Musite nejprve stisknou tlacitko SET_Krok ! Pri prenosu hodinovych
-- inpulsu ze vstupu CLK_IN na vystup CLK_OUT a stisku tlacitka
-- CLEAR_Krok se nic nestane !!! 

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity hodiny is
    Port ( CLK_IN : in std_logic;
	 		  SET_Hodiny : in std_logic;
           SET_Krok : in std_logic;
			  CLEAR_Krok : in std_logic;
			  CLK_OUT : out std_logic);
end hodiny;

architecture R_S of hodiny is
	signal y1, y2 : std_logic;				-- Vnitrni promenne
begin

	process (SET_Krok, SET_Hodiny, CLEAR_Krok) begin

    if (SET_Krok = '0') then				-- Jeden R-S obvod
     y1 <= '0';
     elsif ( SET_Hodiny = '0') then
     y1 <= '1';								-- Vynulovat tl. SET_Krok
	  y2 <= '1';								-- Vynulovat tl. CLEAR_Krok
    end if;

	 if (CLEAR_Krok = '0') then			-- Druhy R-S obvod
     y2 <= '1';
     elsif ( SET_Krok = '0') then
     y2 <= '0';
    end if;
   end process;

 CLK_OUT <= not y2 or (CLK_IN and y1);	-- Celkovy soucet vsech R-S klopnych obvodu a vstupu CLK_IN

end R_S;

