--
-- by HaCeSOFT
--
-- Datum : 17.9.2001
--
--	
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY VYV_DESKA IS
  PORT (clk : IN  STD_LOGIC;
        reset : IN  STD_LOGIC;
		  enable	: in std_logic;
        adresa : in std_logic_vector(1 downto 0);
        S : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
        Q : OUT STD_LOGIC_VECTOR(6 DOWNTO 0);
        BCD : IN STD_LOGIC_VECTOR(4 DOWNTO 0);
		  DT : out std_logic;
		  sloupce : IN std_logic_vector(3 downto 0);          
		  radky : OUT std_logic_vector(2 downto 0);
		  vystup_LED1 : OUT std_logic_vector(11 downto 0);
		  CLK_IN : IN std_logic;
		  CLK_OUT : OUT std_logic;
		  SET_Hodiny : IN std_logic;
		  SET_Krok : IN std_logic;
		  CLEAR_Krok : IN std_logic
		  );
END VYV_DESKA;

ARCHITECTURE structural OF VYV_DESKA IS
COMPONENT hodiny
	PORT(
		CLK_IN : IN std_logic;
		SET_Hodiny : IN std_logic;
		SET_Krok : IN std_logic;
		CLEAR_Krok : IN std_logic;          
		CLK_OUT : OUT std_logic
		);
	END COMPONENT;

	COMPONENT klavesnice
	PORT(
		sloupce : IN std_logic_vector(3 downto 0);
		reset : IN std_logic;
		clk : IN std_logic;          
		radky : OUT std_logic_vector(2 downto 0);
		vystup_LED1 : OUT std_logic_vector(11 downto 0)
		);
	END COMPONENT;

	COMPONENT display
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		clk_e : IN std_logic;
		DT : out std_logic;
		adresa : IN std_logic_vector(1 downto 0);
		BCD : IN std_logic_vector(4 downto 0);          
		S : OUT std_logic_vector(3 downto 0);
		Q : OUT std_logic_vector(6 downto 0)
		);
	END COMPONENT;
begin

	Inst_display: DISPLAY PORT MAP(
		clk => clk,
		reset => reset,
		DT => DT,
		clk_e => enable,
		adresa => adresa,
		S => S,
		Q => Q,
		BCD => BCD
	);

	Inst_klavesnice: klavesnice PORT MAP(
		sloupce => sloupce,
		radky => radky,
		vystup_LED1 => vystup_LED1,
		reset => reset,
		clk => clk 
	);

	Inst_hodiny: hodiny PORT MAP(
		CLK_IN => CLK_IN,
		SET_Hodiny => SET_Hodiny,
		SET_Krok => SET_Krok,
		CLEAR_Krok => CLEAR_Krok,
		CLK_OUT => CLK_OUT
	);

END structural;
