--
-- by HaCeSOFT
--
-- Datum : 7.5.2001
--
--	
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity scitat_multiplex is
    Port (clk : in std_logic;
          reset : in std_logic;
			 DT : out std_logic;
			 bcd1_in : in std_logic_vector(19 downto 0);
			 Q : out std_logic_vector(6 downto 0);
          S : out STD_LOGIC_VECTOR (3 downto 0));
end scitat_multiplex;

architecture behavioral of scitat_multiplex is 
signal S_bin : std_logic_vector(1 downto 0);
signal HEX : std_logic_vector(3 downto 0);
begin

process (clk, reset) begin
 if reset = '0' then
  S_bin <= "11";
 elsif clk = '1' and clk'event then
  S_bin <= S_bin + 1;
  case S_bin is	-- dekoder 1 ze 4. Pro vyber prave zobrazovaneho cisla.
   when "01" => S <= "0001";
   when "10" => S <= "0010";
   when "11" => S <= "0100";
   when "00" => S <= "1000";
   when others => NULL;
  end case;

  case S_bin is
   when "00" => HEX <= bcd1_in (3 downto 0);
					  DT <= bcd1_in (4);
   when "01" => HEX <= bcd1_in (8 downto 5);
				     DT <= bcd1_in (9);
   when "10" => HEX <= bcd1_in (13 downto 10);
				     DT <= bcd1_in (14);
   when "11" => HEX <= bcd1_in (18 downto 15);
					  DT <= bcd1_in (19);
   when others => HEX <= "1111";
  end case;

--  case S_bin is
--   when "00" => DT <= bcd1_in (4);
--	when "01" => DT <= bcd1_in (9);
--   when "10" => DT <= bcd1_in (14);
--	when "11" => DT <= bcd1_in (19);
--   when others => DT <= "1";
--  end case;


  	case HEX is  -- dekoder BCD kodu na segmentovy kod.
		when "0000" => Q <= "1000000";  --0
      when "0001" => Q <= "1111001";  --1
      when "0010" => Q <= "0100100";  --2
      when "0011" => Q <= "0110000";  --3
      when "0100" => Q <= "0011001";  --4
      when "0101" => Q <= "0010010";  --5
      when "0110" => Q <= "0000010";  --6
      when "0111" => Q <= "1111000";  --7
		when "1000" => Q <= "0000000";  --8
		when "1001" => Q <= "0010000";  --9
      when "1010" => Q <= "0001000";  --10
      when "1011" => Q <= "0000011";  --11
      when "1100" => Q <= "1000110";  --12
      when "1101" => Q <= "0100001";  --13
      when "1110" => Q <= "0000110";  --14
      when "1111" => Q <= "1111111";  --15
      when others => Q <= "1111111";
	end case;
end if;

end process;
end behavioral;
